package com.sofeh.devicestate;

import android.os.Build;
import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.text.format.DateUtils;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

public class BuildActivity extends Activity {
	
	String lineSep = System.getProperty("line.separator");

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_build);
		
		String[] listItem = new String[]{ 
				"Version",
				"Board",
				"Boot Loader",
				"Brand",
				"CPU ABI",
				"CPU ABI 2",
				"Device",
				"Finger Print",
				"Hardware",
				"Host",
				"ID",
				"Manufacturer",
				"Model",
				"Product",
				"Radio",
				"Serial",
				"Tags",
				"Time",
				"Type",
				"Unknown",
				"User"
		};
		
		final String[] listInfo = new String[]{ 
				Build.DISPLAY,
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
				"",
		};
		
		@SuppressWarnings("deprecation")
		final String[] listData = new String[]{ 
				"Code Name: "+Build.VERSION.CODENAME+lineSep+
				"Incremental: "+Build.VERSION.INCREMENTAL+lineSep+
				"Release: "+Build.VERSION.RELEASE+lineSep+
				"SDK: "+Integer.toString(Build.VERSION.SDK_INT),
				
				Build.BOARD,
				Build.BOOTLOADER,
				Build.BRAND,
				Build.CPU_ABI,
				Build.CPU_ABI2,
				Build.DEVICE,
				Build.FINGERPRINT,
				Build.HARDWARE,
				Build.HOST,
				Build.ID,
				Build.MANUFACTURER,
				Build.MODEL,
				Build.PRODUCT,
				
				Build.RADIO,
				//"Version: "+Build.getRadioVersion(),
				
				Build.SERIAL,
				Build.TAGS,
				DateUtils.formatDateTime(this, Build.TIME, DateUtils.FORMAT_SHOW_DATE | DateUtils.FORMAT_SHOW_TIME | DateUtils.FORMAT_SHOW_YEAR),
				Build.TYPE,
				Build.UNKNOWN,
				Build.USER
		};

		ListView listView = (ListView) findViewById(R.id.listView1);
		
		ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, R.layout.list_layout, R.id.text1, listItem) 
	    {
			@Override
	    	public View getView(int position, View convertView, ViewGroup parent) {
	    	  View view = super.getView(position, convertView, parent);
	    	  
	    	  //TextView text1 = (TextView) view.findViewById(R.id.text1);
	    	  TextView text2 = (TextView) view.findViewById(R.id.text2);
	    	  TextView text3 = (TextView) view.findViewById(R.id.text3);
	    	  view.findViewById(R.id.imageView1).setVisibility(View.INVISIBLE);
	    	  
	    	  text2.setText(listInfo[position]);
	    	  text3.setText(listData[position]);
	
	    	  if (listInfo[position] == "") 
	    		  text2.setVisibility(View.GONE);
	    	  else
	    		  text2.setVisibility(View.VISIBLE);
	    	  
	    	  return view;
	    	}
	    };	    
        listView.setAdapter(adapter);
        
	    listView.setClickable(false);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.build, menu);
		return true;
	}
	
    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
    	//check selected menu item
    	switch (item.getItemId()) {
			case R.id.action_more :
    			startActivity(new Intent(android.provider.Settings.ACTION_DEVICE_INFO_SETTINGS));
    			break;
    		case R.id.action_back :
    			this.finish();
    			break;
    	}
		return true;
    }
}
