package com.sofeh.devicestate;

import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.annotation.TargetApi;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.DialogInterface;
import android.content.Intent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;

public class LocationActivity extends Activity {

	String[] listItem = new String[]{ //permission: ACCESS_FINE_LOCATION.
			"Providers",
			"Location (GPS)",
			"Location (Network)",
			"Location (Passive)"
		};
	
	ArrayAdapter<String> adapter;
	
	String lineSep = System.getProperty("line.separator");
	
	LocationManager locationManager;
	LocationListener locationListener;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_location);
		
		ListView listView = (ListView) findViewById(R.id.listView1);
		
    	locationManager = (LocationManager)getSystemService(LOCATION_SERVICE);
    	
	    adapter = new ArrayAdapter<String>(this, R.layout.list_layout, R.id.text1, listItem) 
	    {
			@Override
	    	public View getView(int position, View convertView, ViewGroup parent) {
	    	  View view = super.getView(position, convertView, parent);
	    	  //TextView text1 = (TextView) view.findViewById(R.id.text1);
	    	  TextView text2 = (TextView) view.findViewById(R.id.text2);
	    	  TextView text3 = (TextView) view.findViewById(R.id.text3);
	    	  ImageView imageView1 = (ImageView) view.findViewById(R.id.imageView1);
	    	  ImageView imageView2 = (ImageView) view.findViewById(R.id.imageView2);
	    	  
	    	  String str2 = "";
	    	  String str3 = "";
	    	  int image = R.drawable.warning;
	    	  imageView2.setVisibility(View.INVISIBLE);
	    	  
	  		  if (locationManager == null) position = -1;
	  		  
	    	  switch (position) {
	    	  	case -1 : 
	    	  		image = R.drawable.warning;
	    	  		str2 = "Error";
	    	  		break;
	    	  	case 0 : 
	    	  		image = R.drawable.telephony_name;
	    	  		str2 = "Location Provider list";
	    	  		str3 = locationManager.getAllProviders().toString();
	    	  		break;
	    	  	case 1 : 
	    	  		image = R.drawable.telephony_location;
    	  			str2 = "Using satellites";
	    	  		if (locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER) == null)
	    	  			str3 = "not available";
	    	  		else
	    	  		{	
	    	  			Location location = locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
	    	  			str3 = "Latitude: "+location.getLatitude()+" degrees"+lineSep+
	    	  				   "Longitude: "+location.getLongitude()+" degrees"+lineSep+
	    	  				   "Altitude: "+location.getAltitude()+" meters above sea level"+lineSep+
	    	  				   "Accuracy: "+location.getAccuracy()+" meters"+lineSep+
	    	  				   "Bearing: "+location.getBearing()+" degrees"+lineSep+
	    	  				   "Speed: "+location.getSpeed()+" meters/second over ground"+lineSep+
	    	  				   "Time: "+location.getTime()+" UTC (in milliseconds since January 1, 1970)";
		    	  		imageView2.setVisibility(View.VISIBLE);
	    	  		}	
	    	  		break;
	    	  	case 2 : 
    	  			str2 = "Based on availability of cell tower and WiFi access points";
	    	  		image = R.drawable.telephony_location;
	    	  		if (locationManager.getLastKnownLocation(LocationManager.NETWORK_PROVIDER) == null)
	    	  			str3 = "not available";
	    	  		else
	    	  		{	
	    	  			Location location = locationManager.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
	    	  			str3 = "Latitude: "+location.getLatitude()+" degrees"+lineSep+
	    	  				   "Longitude: "+location.getLongitude()+" degrees"+lineSep+
	    	  				   "Altitude: "+location.getAltitude()+" meters above sea level"+lineSep+
	    	  				   "Accuracy: "+location.getAccuracy()+" meters"+lineSep+
	    	  				   "Bearing: "+location.getBearing()+" degrees"+lineSep+
	    	  				   "Speed: "+location.getSpeed()+" meters/second over ground"+lineSep+
	    	  				   "Time: "+location.getTime()+" UTC (in milliseconds since January 1, 1970)";
		    	  		imageView2.setVisibility(View.VISIBLE);
	    	  		}	
	    	  		break;
	    	  	case 3 : 
	    	  		image = R.drawable.telephony_location;
	    	  		str2 = "Passively receive location updates";
	    	  		if (locationManager.getLastKnownLocation(LocationManager.PASSIVE_PROVIDER) == null)
	    	  			str3 = "not available";
	    	  		else
	    	  		{	
	    	  			Location location = locationManager.getLastKnownLocation(LocationManager.PASSIVE_PROVIDER);
	    	  			str3 = "Latitude: "+location.getLatitude()+" degrees"+lineSep+
	    	  				   "Longitude: "+location.getLongitude()+" degrees"+lineSep+
	    	  				   "Altitude: "+location.getAltitude()+" meters above sea level"+lineSep+
	    	  				   "Accuracy: "+location.getAccuracy()+" meters"+lineSep+
	    	  				   "Bearing: "+location.getBearing()+" degrees"+lineSep+
	    	  				   "Speed: "+location.getSpeed()+" meters/second over ground"+lineSep+
	    	  				   "Time: "+location.getTime()+" UTC (in milliseconds since January 1, 1970)";
		    	  		imageView2.setVisibility(View.VISIBLE);
	    	  		}	
	    	  		break;
	    	  }		
	    	  text2.setText(str2);
	    	  text3.setText(str3);
	    	  imageView1.setImageResource(image);
	    	  return view;
			}  
	    };
	    
        listView.setAdapter(adapter);
	    
	    listView.setClickable(true);
	    listView.setOnItemClickListener(new OnItemClickListener() {
            @TargetApi(Build.VERSION_CODES.HONEYCOMB)
			@Override
            public void onItemClick(AdapterView<?> parent, View view,
                    int position, long id) {

    			String provider = "";
            	switch (position) {
            		case 1 :
            			provider = LocationManager.GPS_PROVIDER;
            			break;
            		case 2 :	
            			provider = LocationManager.NETWORK_PROVIDER;
            			break;
            		case 3 :	
            			provider = LocationManager.PASSIVE_PROVIDER;
            			break;
            	};
            	
            	final Location location = locationManager.getLastKnownLocation(provider);
            	if ((provider != "") && (location != null))
    	  		{	
        			new AlertDialog.Builder(LocationActivity.this)
          	    	.setTitle(listItem[position])
  	      	    	.setNegativeButton("cancel", null)
          	    	.setItems(new String[] {"Share", "Copy to Clipboard", "Show on Map"}, new DialogInterface.OnClickListener() {
          	    		public void onClick(DialogInterface dialog, int which) {
          	    			Intent intent;
  	    					String url = "https://maps.google.com/maps?z=14&t=k&q=loc:"+location.getLatitude()+"+"+location.getLongitude();
          	    			switch (which) {
          	    				case 0:
          	    					intent = new Intent(Intent.ACTION_SEND); 
          	    				    intent.setType("text/plain");
          	    				    intent.putExtra(Intent.EXTRA_TEXT, "I'm here: "+lineSep+
          	    				    								   "Latitude: "+location.getLatitude()+lineSep+
          	    				    								   "Longitude: "+location.getLongitude()+lineSep+
          	    				    								   "Altitude: "+location.getAltitude()+lineSep+
          	    				    		                           url);
          	    				    startActivity(Intent.createChooser(intent, "Share via"));
          	    					break;
          	    					
          	    				case 1 :
          	    					ClipboardManager clipboard = (ClipboardManager) getSystemService(CLIPBOARD_SERVICE); 
          	    					ClipData clip = ClipData.newPlainText("Location", location.getLatitude()+", "+
          	    																   	  location.getLongitude()+", "+
          	    																   	  location.getAltitude());
          	    					clipboard.setPrimaryClip(clip);
          	    					break;
          	    				
          	    				case 2 :	
          	    					startActivity(new Intent(Intent.ACTION_VIEW).setData(Uri.parse(url)));
          	    					break;
    						}
          	    		}
          	    	})
          	    	.show();
    	  		};	
            }
        });		
	    
	    locationListener = new LocationListener() {

			@Override
			public void onLocationChanged(Location arg0) {
        		adapter.notifyDataSetChanged(); // Refresh List
			}

			@Override
			public void onProviderDisabled(String arg0) {
        		adapter.notifyDataSetChanged(); // Refresh List
			}

			@Override
			public void onProviderEnabled(String arg0) {
        		adapter.notifyDataSetChanged(); // Refresh List
			}

			@Override
			public void onStatusChanged(String arg0, int arg1, Bundle arg2) {
        		adapter.notifyDataSetChanged(); // Refresh List
			}
	    	
	    };
	    
	    if (locationManager.getProvider(LocationManager.GPS_PROVIDER) != null)
	    	locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, locationListener);
	    if (locationManager.getProvider(LocationManager.NETWORK_PROVIDER) != null)
	    	locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 0, locationListener);
	    if (locationManager.getProvider(LocationManager.PASSIVE_PROVIDER) != null)
	    	locationManager.requestLocationUpdates(LocationManager.PASSIVE_PROVIDER, 0, 0, locationListener);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.location, menu);
		return true;
	}

    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
    	//check selected menu item
    	switch (item.getItemId()) {
    		case R.id.action_back :
    			this.finish();
    			break;
    	}
		return true;
    }
    
    @Override
    public void onDestroy() {
	    locationManager.removeUpdates(locationListener);
        super.onDestroy();
    }
}
