package com.sofeh.devicestate;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.Arrays;

import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {

	ArrayAdapter<String> adapter;
	ListView listView;
	ProgressBar progressBar;
	String lineSep = System.getProperty("line.separator");
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		final String[] listItem = new String[]{"   Hardware",
										 	   getString(R.string.title_activity_sensor),
										 	   getString(R.string.title_activity_telephony),
										 	   getString(R.string.title_activity_location),
										 	   "   Software",
											   getString(R.string.title_activity_build),
										 	   getString(R.string.title_activity_application),
										 	   getString(R.string.title_activity_task),
										 	   "   Tools",
										 	   getString(R.string.title_activity_mime_type),
										 	   getString(R.string.title_activity_shredder)};
		final String[] listInfo = new String[]{"",
											   "Sensors information and real-time data", 
											   "Telephony information and real-time state",
											   "Loaction providers and real-time data",
											   "",
											   "Device information",
											   "Installed Packages with information and tools",
											   "Running Applications",
											   "",
											   "MIME (Multipurpose Internet Mail Extensions) Types by File Extension",
											   "Delete Files Permanently and Makes sure that no data thief can get his hands on your sensitive data"};
		final int[] listlmage = new int[]{0,
										  R.drawable.sensor, 
										  R.drawable.telephony, 
										  R.drawable.telephony_location,
										  0,
				  						  R.drawable.information,
										  R.drawable.application,
										  R.drawable.running,
										  0,
										  R.drawable.telephony_name,
										  R.drawable.shredder};
		
		listView = (ListView) findViewById(R.id.listView1);
		progressBar = (ProgressBar) findViewById(R.id.progressBar1);
		
	    adapter = new ArrayAdapter<String>(this, R.layout.list_layout , R.id.text1, listItem) 
	    {
			@Override
	    	public View getView(int position, View convertView, ViewGroup parent) {
	    	  View view = super.getView(position, convertView, parent);
	    	  TextView text1 = (TextView) view.findViewById(R.id.text1);
	    	  TextView text2 = (TextView) view.findViewById(R.id.text2);
	    	  TextView text3 = (TextView) view.findViewById(R.id.text3);
	    	  ImageView imageView1 = (ImageView) view.findViewById(R.id.imageView1);
	    	  
 	    	  if (listlmage[position] == 0) {
  	    		  imageView1.setVisibility(View.GONE);
 	    		  text1.setVisibility(View.GONE);
  	    		  text3.setVisibility(View.GONE);
 		    	  view.findViewById(R.id.imageView2).setVisibility(View.GONE);
 	    		  view.setBackgroundColor(Color.rgb(180,190,240));
 	    		  
 	    		  view.getLayoutParams().height =  (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, 32, getResources().getDisplayMetrics());
 	    		
 	    		  text2.setText(listItem[position]);
 	    		  text2.setShadowLayer(2, 2, 2, Color.GRAY);
 	    		  text2.getLayoutParams().height = view.getLayoutParams().height;
 	    		  text2.setTextColor(Color.WHITE);
 	    		  text2.setGravity(Gravity.CENTER_VERTICAL);
 	    	  }
 	    	  else
 	    	  {
  	    		  imageView1.setVisibility(View.VISIBLE);
 	    		  text1.setVisibility(View.VISIBLE);
  	    		  text3.setVisibility(View.GONE);
 		    	  view.findViewById(R.id.imageView2).setVisibility(View.VISIBLE);
 	    		  view.setBackgroundColor(0);
 	    		  
 		    	  text2.setText(listInfo[position]);
 	    		  text2.setShadowLayer(0, 0, 0, 0);
 	    		  text2.setTextColor(Color.BLACK);
 	 	    	  imageView1.setImageResource(listlmage[position]);
 	 	    	  
 	    		  view.getLayoutParams().height = ViewGroup.LayoutParams.WRAP_CONTENT;
 	    		  text2.getLayoutParams().height = ViewGroup.LayoutParams.WRAP_CONTENT; 
 	    	  };
 	    		  
	    	  return view;
	    	}
	    };	    
	    listView.setAdapter(adapter);
	    
	    listView.setClickable(true);
	    listView.setOnItemClickListener(new OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                    int position, long id) {

            	switch (position) {
            		case 0 : break;
            		case 1 : 
                    	progressBar.setVisibility(View.VISIBLE);
            			startActivity(new Intent(MainActivity.this, SensorActivity.class));
            			break;
            		case 2 :	
                    	progressBar.setVisibility(View.VISIBLE);
            			startActivity(new Intent(MainActivity.this, TelephonyActivity.class));
            			break;
            		case 3 :	
                    	progressBar.setVisibility(View.VISIBLE);
            			startActivity(new Intent(MainActivity.this, LocationActivity.class));
            			break;
            		case 4 : break;
            		case 5 :
                    	progressBar.setVisibility(View.VISIBLE);
            			startActivity(new Intent(MainActivity.this, BuildActivity.class));
            			break;
            		case 6 :
                    	progressBar.setVisibility(View.VISIBLE);
            			startActivity(new Intent(MainActivity.this, ApplicationActivity.class));
            			break;
            		case 7 : 
                    	progressBar.setVisibility(View.VISIBLE);
            			startActivity(new Intent(MainActivity.this, TaskActivity.class));
            			break;
            		case 8 : break;
            		case 9 : 
                    	progressBar.setVisibility(View.VISIBLE);
            			startActivity(new Intent(MainActivity.this, MimeTypeActivity.class));
            			break;
            		case 10 : 
                    	progressBar.setVisibility(View.VISIBLE);
            		    Intent intent = new Intent(Intent.ACTION_GET_CONTENT); 
            		    intent.setType("*/*"); 
            		    intent.addCategory(Intent.CATEGORY_OPENABLE);
            		    try {
            		        startActivityForResult(Intent.createChooser(intent, "Select a File to Delete Permanently"), 1000);
            		    } catch (android.content.ActivityNotFoundException ex) {
            		        Toast.makeText(MainActivity.this, "Please install a File Manager.", Toast.LENGTH_SHORT).show();
            		    }
            			break;
            	}
            }
        });		
	}

	@Override
	public void onResume() {
	  super.onResume();    
  	  progressBar.setVisibility(View.GONE);
	}	
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
	    switch (requestCode) {
	        case 1000:
	        	if (resultCode == RESULT_OK) {
	            // Get the Uri: Uri uri = data.getData();
	        	// Get the Path: String path = data.getData().getPath();
	            // Get the file instance: File file = new File(path);
	        		final String path = data.getData().getPath();
	        		
	        		new AlertDialog.Builder(this)
	        		.setTitle("Warning")
	      	    	.setMessage("Are you sure? do you want to Delete this File Permanently? "+lineSep+path)
	      	    	.setIcon(R.drawable.warning)
	      	    	.setPositiveButton("Delete!", new DialogInterface.OnClickListener() {
	      	    	    public void onClick(DialogInterface dialog, int which) {
	      	    	    	final File file = new File(path);
	      	    	    	file.setWritable(true);
	      	    	    	if (file.canWrite())
	      	    	    	{	
	      	    	    		try {
	      	    	    			byte[] buf = new byte[1024*100];
	      	    	    			long pos;
	      	    	    			
	      	    	    			RandomAccessFile raFile;
	      	    	    			// rewrite with 0xFF
	      	    	    			Arrays.fill(buf, (byte) 0xFF);
									raFile = new RandomAccessFile(file, "rw");
									raFile.seek(0);
									pos = 0;
									while (pos < raFile.length()) {
										raFile.write(buf);
										pos = pos + buf.length;
									}
	      	    	    			raFile.close();
	      	    	    			// rewrite again with 0x00
	      	    	    			Arrays.fill(buf, (byte) 0x00);
									raFile = new RandomAccessFile(file, "rw");
									raFile.seek(0);
									pos = 0;
									while (pos < raFile.length()) {
										raFile.write(buf);
										pos = pos + buf.length;
									}
	      	    	    			raFile.close();
	      	    	    			// delete
	      	    	    			file.delete();
      	    	    			} catch (IOException e) {
									e.printStackTrace();
								}
							}	
	      	    	    	else
	      	    		        Toast.makeText(MainActivity.this, "File is write protect.", Toast.LENGTH_SHORT).show();
	      	    	    }
	      	    	})
	      	    	.setNegativeButton("Cancel", null)
	      	    	.show();
	        	};
	        	break;
	    }
	    super.onActivityResult(requestCode, resultCode, data);
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
    	//check selected menu item
    	switch (item.getItemId()) {
			case R.id.action_exit :
				this.finish();
    			break;
    		case R.id.action_about :
    			new AlertDialog.Builder(this)
      	    	.setTitle("About")
      	    	.setMessage("Device State v1.00.00"+lineSep+lineSep+
      	    			    "http://www.sofeh.com"+lineSep+
      	    			    "Ramin Jafari")
      	    	//.setIcon(android.R.drawable.ic_dialog_info)
      	    	.setPositiveButton("Ok", null)
      	    	.show();
    			break;
    	}
		return true;
    }
}

