package com.sofeh.devicestate;

import android.os.Bundle;
import android.app.Activity;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.Menu;
import android.view.MenuItem;
import android.webkit.MimeTypeMap;
import android.widget.EditText;
import android.widget.TextView;

public class MimeTypeActivity extends Activity {

	String lineSep = System.getProperty("line.separator");
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_mime_type);
		
		final EditText editText = (EditText) findViewById(R.id.editText1);
		final TextView textView = (TextView) findViewById(R.id.textView2);
		
		editText.addTextChangedListener(new TextWatcher() {
			
			@Override
			public void onTextChanged(CharSequence arg0, int arg1, int arg2, int arg3) {
				MimeTypeMap mime = MimeTypeMap.getSingleton();
				String mimeText = (mime.getMimeTypeFromExtension(editText.getText().toString()));
				if (mimeText == null) mimeText = "application/octet-stream (Unknown)";
				textView.setText("Mime Type: "+lineSep+mimeText);
			}
			
			@Override
			public void beforeTextChanged(CharSequence arg0, int arg1, int arg2, int arg3) {
			}
			
			@Override
			public void afterTextChanged(Editable arg0) {
			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.mime_type, menu);
		return true;
	}

    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
    	//check selected menu item
    	switch (item.getItemId()) {
    		case R.id.action_back :
    			this.finish();
    			break;
    	}
		return true;
    }
}
