package com.sofeh.devicestate;

import java.util.List;

import android.net.Uri;
import android.os.Bundle;
import android.provider.Settings;
import android.app.Activity;
import android.app.ActivityManager;
import android.app.AlertDialog;
import android.app.ActivityManager.RunningTaskInfo;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;

public class TaskActivity extends Activity {

	ArrayAdapter<RunningTaskInfo> adapter;
	
	String lineSep = System.getProperty("line.separator");
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_task);
		
		final ListView listView = (ListView) findViewById(R.id.listView1);
		
		final ActivityManager activityManager = (ActivityManager) this.getSystemService(ACTIVITY_SERVICE);
		//final List<RunningAppProcessInfo> processes = activityManager.getRunningAppProcesses();
		//final List<RunningServiceInfo> services = activityManager.getRunningServices(maxNum);
		final List<RunningTaskInfo> tasks = activityManager.getRunningTasks(1024);
		
		final PackageManager packageManager = getApplicationContext().getPackageManager();
		
		//inline if sample: final String applicationName = (String) (ai != null ? pm.getApplicationLabel(ai) : "(unknown)");
		
		adapter = new ArrayAdapter<RunningTaskInfo>(this, R.layout.list_layout, R.id.text1, tasks) 
	    {
			@Override
	    	public View getView(int position, View convertView, ViewGroup parent) {
	    	  View view = super.getView(position, convertView, parent);
	    	  TextView text1 = (TextView) view.findViewById(R.id.text1);
	    	  TextView text2 = (TextView) view.findViewById(R.id.text2);
	    	  TextView text3 = (TextView) view.findViewById(R.id.text3);
	    	  ImageView imageView1 = (ImageView) view.findViewById(R.id.imageView1);
	    	  
	    	  RunningTaskInfo taskInfo = tasks.get(position);
	    	  try {
	    		  ApplicationInfo app = packageManager.getApplicationInfo(taskInfo.baseActivity.getPackageName(), 0);
		    	  text1.setText(packageManager.getApplicationLabel(app));
		    	  imageView1.setImageDrawable(packageManager.getApplicationIcon(app));
		    	  view.findViewById(R.id.imageView2).setVisibility(View.VISIBLE);
	    	  } catch (final NameNotFoundException e) {
		    	  text1.setText(taskInfo.baseActivity.getPackageName());
		    	  imageView1.setImageBitmap(taskInfo.thumbnail);
		    	  view.findViewById(R.id.imageView2).setVisibility(View.GONE);
	    	  }
	    	  text2.setText("ID: "+ taskInfo.id);
	    	  text3.setText(
	    			  "Activities: "+taskInfo.numActivities+" (Running: "+taskInfo.numRunning+")"+lineSep+
	    	    	  "Base Activity: "+taskInfo.baseActivity.flattenToShortString()+lineSep+
	    	    	  "Top Activity: "+taskInfo.topActivity.flattenToShortString());
	    	  
   			  return view;
	    	}
	    };
	    
	    listView.setAdapter(adapter);
        
	    listView.setClickable(true);
	    listView.setOnItemClickListener(new OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                    int position, long id) {

  	    	  	final RunningTaskInfo taskInfo = tasks.get(position);
  	    	  	final ApplicationInfo app;
  	    	  	try {
  	    	  		app = packageManager.getApplicationInfo(taskInfo.baseActivity.getPackageName(), 0);
  	  	    	  	String[] items;
  					if ((app.flags & ApplicationInfo.FLAG_SYSTEM) != 0)
  	  	    	  		items = new String[] {"Switch to", /*"End Task", "End Prosess",*/ "Share", "Manage"};
  					else
  	  	    	  		items = new String[] {"Switch to", /*"End Task", "End Prosess",*/ "Share", "Manage", "Uninstall"};
  	  	    	  	
  	    			new AlertDialog.Builder(TaskActivity.this)
  	      	    	.setTitle(packageManager.getApplicationLabel(app))
  	      	    	.setNegativeButton("cancel", null)
  	      	    	.setItems(items, new DialogInterface.OnClickListener() {
  	      	    		public void onClick(DialogInterface dialog, int which) {
  	      	    			Intent intent;
  	      	    			switch (which) {
  	      	    				case 0:
  	   	    						intent = packageManager.getLaunchIntentForPackage(app.packageName);
  	       	      	    	    	if (intent != null) startActivity(intent);
  	      	    					break;
  	      	    				/*	
  	      	    				case 1 :
  	      	    					activityManager.killBackgroundProcesses(app.packageName);
   	    							adapter.notifyDataSetChanged(); // Refresh List
  	      	    					break;
  	      	    				case 2 :
  	      	    					//for (RunningAppProcessInfo processInfo:processes)
  	      	    					//	if (app.processName.matches(processInfo.processName)){
  	      	    					//		Process.killProcess(processInfo.pid);
  	      	    					//		adapter.notifyDataSetChanged(); // Refresh List
  	      	    					//		break;
  	      	    					//	}	
  	      	    					Method forceStopPackage;                
  	      	    					try {
  	      	    						forceStopPackage = activityManager.getClass().getDeclaredMethod("forceStopPackage", String.class);
  	      	    						forceStopPackage.setAccessible(true);
  	      	    						forceStopPackage.invoke(activityManager, app.packageName);
  	      	    					} catch (NoSuchMethodException e) {
  	      	    						e.printStackTrace();
  	      	    					} catch (IllegalAccessException e) {
										e.printStackTrace();
									} catch (IllegalArgumentException e) {
										e.printStackTrace();
									} catch (InvocationTargetException e) {
										e.printStackTrace();
									}
  	      	    		    		break;*/
  	      	    				case 1 :
  	      	    					intent = new Intent(Intent.ACTION_SEND); 
  	      	    				    intent.setType("application/vnd.android.package-archive");
  	      	    				    intent.putExtra(Intent.EXTRA_STREAM, Uri.parse("file://"+app.sourceDir));
  	      	    				    startActivity(Intent.createChooser(intent, "Share via"));
  	      	    					break;
  	      	    				
  	      	    				case 2 :	
  	      	      	    	    	intent = new Intent();
  	      	      	    	    	intent.setAction(Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
  	      	      	    	        intent.setData(Uri.fromParts("package", app.packageName, null));
  	      	      	            	startActivityForResult(intent, 1000);
  	      	    					break;
  	      	    					
  	      	    				case 3 :	
  	      	      	            	startActivityForResult(new Intent(Intent.ACTION_DELETE, Uri.fromParts("package", app.packageName, null)), 1000);
  	      	    					break;
  							}
  	      	    		}
  	      	    	})
  	      	    	.show();
  	    	  	} catch (final NameNotFoundException e) {
  	    	  	}
            }
        });		
	}    

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
	    switch (requestCode) {
	        case 1000:
        		adapter.notifyDataSetChanged(); // Refresh List
	        	break;
	    }
	    super.onActivityResult(requestCode, resultCode, data);
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.task, menu);
		return true;
	}

    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
    	//check selected menu item
    	switch (item.getItemId()) {
			case R.id.action_more :
    			startActivity(new Intent(android.provider.Settings.ACTION_APPLICATION_SETTINGS));
    			break;
    		case R.id.action_back :
    			this.finish();
    			break;
    	}
		return true;
    }
}
