package com.sofeh.devicestate;

import java.util.Timer;
import java.util.TimerTask;

import android.os.Bundle;
import android.app.Activity;
import android.telephony.TelephonyManager;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

public class TelephonyActivity extends Activity {

	ArrayAdapter<String> adapter;
	//String lineSep = System.getProperty("line.separator");
	TelephonyManager telephonyManager = null;
    ListView listView;
	
	String[] listItem = new String[]{ // permission: READ_PHONE_STATE
			"Call State", 			// CALL_STATE_IDLE, CALL_STATE_OFFHOOK, CALL_STATE_RINGING
			"Cell Location", 		//permission: ACCESS_COARSE_LOCATIONorACCESS_FINE_LOCATION.
			"Data Activity", 		// DATA_ACTIVITY_NONE, DATA_ACTIVITY_IN, DATA_ACTIVITY_OUT, DATA_ACTIVITY_INOUT, DATA_ACTIVITY_DORMANT
			"Data State", 			// DATA_DISCONNECTED, DATA_CONNECTING, DATA_CONNECTED, DATA_SUSPENDED
			"Device Id",
			"Device Software Version",
			//"Group Id Level1",
			"Line 1 Number",
			//"Mms UA Prof Url",
			//"Mms User Agent",
			"Network Country Iso",
			"Network Operator",
			"Network Operator Name",
			"Network Type", 		// NETWORK_TYPE_xxxx 
			"Phone Type",			// PHONE_TYPE_NONE, PHONE_TYPE_GSM, PHONE_TYPE_CDMA, PHONE_TYPE_SIP
			"Sim State", 			// SIM_STATE_UNKNOWN, SIM_STATE_ABSENT, SIM_STATE_PIN_REQUIRED, SIM_STATE_PUK_REQUIRED, SIM_STATE_NETWORK_LOCKED, SIM_STATE_READY
			"Sim Country Iso",
			"Sim Operator",
			"Sim Operator Name",
			"Sim Serial Number",
			"Subscriber Id",
			"Voice Mail AlphaTag",
			"Voice Mail Number",
			"Has ICC Card?",
			"Is Network Roaming?"
		};
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_telephony);

		listView = (ListView) findViewById(R.id.listView1);
		
    	telephonyManager = (TelephonyManager)getSystemService(TELEPHONY_SERVICE);
    	
	    adapter = new ArrayAdapter<String>(this, R.layout.list_layout, R.id.text1, listItem) 
	    {
			@Override
	    	public View getView(int position, View convertView, ViewGroup parent) {
	    	  View view = super.getView(position, convertView, parent);
	    	  //TextView text1 = (TextView) view.findViewById(R.id.text1);
	    	  TextView text2 = (TextView) view.findViewById(R.id.text2);
	    	  TextView text3 = (TextView) view.findViewById(R.id.text3);
	    	  ImageView imageView1 = (ImageView) view.findViewById(R.id.imageView1);
	    	  
	    	  String str2 = "";
	    	  String str3 = "";
	    	  int image = R.drawable.warning;
	    	  
	  		  if (telephonyManager == null) position = -1;
	  		  
	    	  switch (position) {
	    	  	case -1 : 
	    	  		image = R.drawable.warning;
	    	  		str2 = "Error";
	    	  		break;
	    	  	case 0 : 
	    	  		image = R.drawable.telephony_callstate;
    	  			str2 = "Call state (cellular) on the device";
	    	  		switch (telephonyManager.getCallState()) { 
	    	  			case TelephonyManager.CALL_STATE_IDLE :
	    	  				str3 = "No activity (Idle)";
	    	    	  		break;
	    	  			case TelephonyManager.CALL_STATE_OFFHOOK :
	    	  				str3 = "At least one call exists that is dialing, active, or on hold, and no calls are ringing or waiting (Off hook)";
	    	    	  		break;
	    	  			case TelephonyManager.CALL_STATE_RINGING :
	    	  				str3 = " A new call arrived and is ringing or waiting (Ringing)";
	    	    	  		break;
	    	  		}  		
	    	  		break;
	    	  	case 1 :	
	    	  		image = R.drawable.telephony_location;
	    	  		if (telephonyManager.getCellLocation() == null)
	    	  			str2 = "Flight mode is ON";
	    	  		else
	    	  		{	
	    	  			str2 = "Current location of the device";
    	  				str3 = telephonyManager.getCellLocation().toString();
	    	  		}	
	    	  		break;
	    	  	case 2 :	
	    	  		image = R.drawable.telephony_data;
	    	  		str2 = "Activity on a data connection (cellular)";
	    	  		switch (telephonyManager.getDataActivity()) {
	    	  			case TelephonyManager.DATA_ACTIVITY_NONE :
	    	  				str3 = "No traffic (None)";
	    	    	  		break;
	    	  			case TelephonyManager.DATA_ACTIVITY_IN :
	    	  				str3 = "Currently receiving IP PPP traffic (In)";
	    	    	  		break;
	    	  			case TelephonyManager.DATA_ACTIVITY_OUT :
	    	  				str3 = "Currently sending IP PPP traffic (Out)";
	    	    	  		break;
	    	  			case TelephonyManager.DATA_ACTIVITY_INOUT :
	    	  				str3 = "Currently both sending and receiving IP PPP traffic (In/Out)";
	    	    	  		break;
	    	  			case TelephonyManager.DATA_ACTIVITY_DORMANT :
	    	  				str3 = "Data connection is active, but physical link is down (Dormant)";
	    	    	  		break;
	    	  		}
	    	  		break;
	    	  	case 3 :	
	    	  		image = R.drawable.telephony_data;
	    	  		str2 = "Current data connection state (cellular)";
	    	  		switch (telephonyManager.getDataState()) {
	    	  			case TelephonyManager.DATA_DISCONNECTED : 
	    	  				str3 = "IP traffic not available (Disconnected)";
	    	    	  		break;
	    	  			case TelephonyManager.DATA_CONNECTING : 
	    	  				str3 = "Currently setting up a data connection (Connecting)";
	    	    	  		break;
	    	  			case TelephonyManager.DATA_CONNECTED : 
	    	  				str3 = "IP traffic should be available (Connected)";
	    	    	  		break;
	    	  			case TelephonyManager.DATA_SUSPENDED :
	    	  				str3 = "The connection is up, but IP traffic is temporarily unavailable (Suspended)";
	    	    	  		break;
	    	  		}
	    	  		break;
	    	  	case 4 :	
	    	  		image = R.drawable.telephony_number;
	    	  		str2 = "Unique device ID (IMEI for GSM/ MEID or ESN for CDMA)";
	    	  		str3 = telephonyManager.getDeviceId();
	    	  		break;
	    	  	case 5 :	
	    	  		image = R.drawable.information;
	    	  		str2 = "Software version number for the device";
	    	  		str3 = telephonyManager.getDeviceSoftwareVersion();
	    	  		break;
	    	  	//case 6 :	
	    	  		//str = "Group Identifier Level1 for GSM"+lineSep+telephonyManager.getGroupIdLevel1();
	    	  		//break;
	    	  	case 6 :	
	    	  		image = R.drawable.telephony_number;
	    	  		str2 = "Phone number string for line 1";
	    	  		str3 = telephonyManager.getLine1Number();
	    	  		break;
	    	  	//case 8 :	
	    	  		//str = "MMS user agent profile URL"+lineSep+telephonyManager.getMmsUAProfUrl();
	    	  		//break;
	    	  	//case 9 :	
	    	  		//str = telephonyManager.getMmsUserAgent();
	    	  		//break;
	    	  	case 7 :	
	    	  		image = R.drawable.telephony_name;
	    	  		str2 = "ISO country code equivalent of the current registered operator's MCC (Mobile Country Code)";
	    	  		str3 = telephonyManager.getNetworkCountryIso();
	    	  		break;
	    	  	case 8 :	
	    	  		image = R.drawable.telephony_number;
	    	  		str2 = "The numeric name (MCC+MNC) of current registered operator";
	    	  		str3 = telephonyManager.getNetworkOperator();
	    	  		break;
	    	  	case 9 :	
	    	  		image = R.drawable.telephony_name;
	    	  		str2 = "The alphabetic name of current registered operator";
	    	  		str3 = telephonyManager.getNetworkOperatorName();
	    	  		break;
	    	  	case 10 :	
	    	  		image = R.drawable.telephony_data;
	    	  		str2 = "Network type for current data connection";
	    	  		switch (telephonyManager.getNetworkType()) {
	    	  			case TelephonyManager.NETWORK_TYPE_1xRTT : 
	    	  				str3 = "1xRTT";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_CDMA : 
	    	  				str3 = "CDMA";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_EDGE : 
	    	  				str3 = "EDGE";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_EHRPD :
	    	  				str3 = "EHRPD";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_EVDO_0 :
	    	  				str3 = "EVDO 0";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_EVDO_A :
	    	  				str3 = "EVDO A";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_EVDO_B :
	    	  				str3 = "EVDO B";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_GPRS :
	    	  				str3 = "GPRS";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_HSDPA :
	    	  				str3 = "HSDPA";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_HSPA :
	    	  				str3 = "HSPA";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_HSPAP :
	    	  				str3 = "HSPAP";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_HSUPA :
	    	  				str3 = "HSUPA";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_IDEN :
	    	  				str3 = "IDEN";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_LTE :
	    	  				str3 = "LTE";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_UMTS :
	    	  				str3 = "UMTS";
	    	    	  		break;
	    	  			case TelephonyManager.NETWORK_TYPE_UNKNOWN :
	    	  				str3 = "UNKNOWN";
	    	    	  		break;
	    	  		}
	    	  		break;
	    	  	case 11 :	
	    	  		image = R.drawable.telephony;
	    	  		str2 = "Type of radio used to transmit voice calls";
	    	  		switch (telephonyManager.getPhoneType()) {
	    	  			case TelephonyManager.PHONE_TYPE_NONE : 
	    	  				str3 = "None";
	    	    	  		break;
	    	  			case TelephonyManager.PHONE_TYPE_GSM : 
	    	  				str3 = "GSM";
	    	    	  		break;
	    	  			case TelephonyManager.PHONE_TYPE_CDMA : 
	    	  				str3 = "CDMA";
	    	    	  		break;
	    	  			case TelephonyManager.PHONE_TYPE_SIP : 
	    	  				str3 = "SIP";
	    	    	  		break;
	    	  		}
	    	  		break;
	    	  	case 12 :	
	    	  		image = R.drawable.telephony_simstate;
	    	  		str2 = "State of the device SIM card";
	    	  		switch (telephonyManager.getSimState()) {
	    	  			case TelephonyManager.SIM_STATE_UNKNOWN : 
	    	  				str3 = "Signifies that the SIM is in transition between states (Unknown)";
	    	    	  		break;
	    	  			case TelephonyManager.SIM_STATE_ABSENT : 
	    	  				str3 = "No SIM card is available in the device (Absent)";
	    	    	  		break;
	    	  			case TelephonyManager.SIM_STATE_PIN_REQUIRED : 
	    	  				str3 = "SIM card Locked, requires the user's SIM PIN to unlock (PIN Required)";
	    	    	  		break;
	    	  			case TelephonyManager.SIM_STATE_PUK_REQUIRED : 
	    	  				str3 = "SIM card Locked, requires the user's SIM PUK to unlock (PUK Required)";
	    	    	  		break;
	    	  			case TelephonyManager.SIM_STATE_NETWORK_LOCKED : 
	    	  				str3 = "SIM card Locked, requries a network PIN to unlock (Network Locked)";
	    	    	  		break;
	    	  			case TelephonyManager.SIM_STATE_READY : 
	    	  				str3 = "Ready";
	    	    	  		break;
	    	  		}
	    	  		break;
	    	  	case 13 :	
	    	  		image = R.drawable.telephony_number;
	    	  		str2 = "ISO country code equivalent for the SIM provider's country code";
	    	  		str3 = telephonyManager.getSimCountryIso();
	    	  		break;
	    	  	case 14 :	
	    	  		image = R.drawable.telephony_number;
	    	  		str2 = "MCC+MNC of the provider of the SIM (5 or 6 decimal digits)";
	    	  		str3 = telephonyManager.getSimOperator();
	    	  		break;
	    	  	case 15 :	
	    	  		image = R.drawable.telephony_name;
	    	  		str2 = "Service Provider Name (SPN)";
	    	  		str3 = telephonyManager.getSimOperatorName();
	    	  		break;
	    	  	case 16 :	
	    	  		image = R.drawable.telephony_number;
	    	  		str2 = "Serial number of the SIM";
	    	  		str3 = telephonyManager.getSimSerialNumber();
	    	  		break;
	    	  	case 17 :	
	    	  		image = R.drawable.telephony_number;
	    	  		str2 = "";
	    	  		str3 = telephonyManager.getSubscriberId();
	    	  		break;
	    	  	case 18 :	
	    	  		image = R.drawable.telephony_name;
	    	  		str2 = "the alphabetic identifier associated with the voice mail number";
	    	  		str3 = telephonyManager.getVoiceMailAlphaTag();
	    	  		break;
	    	  	case 19 :	
	    	  		image = R.drawable.telephony_number;
	    	  		str2 = "";
	    	  		str3 = telephonyManager.getVoiceMailNumber();
	    	  		break;
	    	  	case 20 :	
	    	  		image = R.drawable.telephony_question;
	    	  		str2 = "Is ICC card present?";
	    	  		if (telephonyManager.hasIccCard()) 
	    	  			str3 = "Yes"; 
	    	  		else 
	    	  			str3 = "No";
	    	  		break;
	    	  	case 21 :	
	    	  		image = R.drawable.telephony_question;
	    	  		str2 = "Is the device considered roaming on the current network (for GSM purposes)?";
	    	  		if (telephonyManager.isNetworkRoaming()) 
	    	  			str3 = "Yes"; 
	    	  		else 
	    	  			str3 = "No";
	    	  		break;
	    	  }		
	    	  text2.setText(str2);
	    	  text3.setText(str3);
	    	  imageView1.setImageResource(image);
	    	  return view;
	    	}
	    };	    
        listView.setAdapter(adapter);
        
	    listView.setClickable(false);
	    
        // Timer
        Timer timer = new Timer();
        timer.schedule(new TimerTask() {
            @Override
            public void run() {
                runOnUiThread(new Runnable() {
                	@Override
                	public void run() {
                    	//telephonyManager = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
                		adapter.notifyDataSetChanged(); // Refresh List
                	}
                });
            	}
        	}, 1000, 1000);
    }

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.telephony, menu);
		return true;
	}
	
    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
    	//check selected menu item
    	switch (item.getItemId()) {
    		case R.id.action_back :
    			this.finish();
    			break;
    	}
		return true;
    }
}
